#include "UserDb.h"

using namespace userdb;

UserDb::UserDb()
{
}

User UserDb::user_by_pin(String cmp)
{
    Serial.println("Stearching for user with pin number " + cmp);
    Iterator it = begin();
    do
    {
        User temp = *it;
        if (temp.user_pin == cmp)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}
User UserDb::user_by_rfid(String cmp)
{
    Serial.println("Stearching for user with rfid " + cmp);
    Iterator it = begin();
    do
    {
        User temp = *it;
        if (temp.rfid_uid == cmp)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}

User UserDb::user_by_uid(unsigned long cmp){
    Serial.println("Stearching for user with user id " + String(cmp));
    Iterator it = begin();
    do
    {
        User temp = *it;
        if (temp.uid == cmp)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}
void UserDb::print_to_serial()
{
    Serial.println("Starting UserDB Test Read");
    // File userdb_file = LittleFS.open("userdb.csv","r");
    // if (!userdb_file)
    //{
    //     Serial.println("Failed to open file for reading");
    //     return;
    // }
    // unsigned int line = 0;
    // while(userdb_file.available()){
    //     String temp = userdb_file.readStringUntil('\n');
    //     User res = read_csv_line(temp);
    //     Serial.println(res.toString());
    //     line++;
    // }
    Iterator it = begin();
    do
    {
        User temp = *it;
        Serial.println(temp.toString());
        ++it;
    } while (it.has_next());
}
